/* Function for getting Mem/Swap usage in percent. - Linux specific code     */
/* Copyright(C) 2001 Seiichi SATO <sato@cvs-net.co.jp>                       */
/* Copyright(C) 2001 John McCutchan <ttb@tentacle.dhs.org>                   */
/* licensed under the GPL                                                    */

/* initialize function */
int
mem_init (void)
{
  return 0;
}

/* return mem/swap usage in percent 0 to 100 */
int
get_memusage (int *per_mem, int *per_swap)
{
  FILE *fp;
  static u_int64_t v11, v12, v13, v14, v15, v16, v21, v22;
  static char drop[2048];

  /* open '/proc/meminfo' */
  fp = fopen ("/proc/meminfo", "r");
  if (!fp)
    {
      puts ("Could not open /proc/meminfo");
      return -1;
    }

  /* get value */
  fgets (drop, 2048, fp);

  /* read in physical memory statistics */
  fscanf (fp, "%*s %Ld %Ld %Ld %Ld %Ld %Ld", &v11, &v12, &v13, &v14, &v15,
	  &v16);

  /* read in swap memory statistics */
  fscanf (fp, "%*s %Ld %Ld", &v21, &v22);

  /* close fp */
  fclose (fp);

  /* calc mem usage in percent */
  *per_mem = 100 * (v12 - v15 - v16) / v11;

  if (!v21)
    {
      *per_swap = 0;
      return 0;
    }
  *per_swap = 100 * v22 / v21;
  return 0;
}
