/* Function for getting Mem/Swap usage in percent. - Solaris specific code   */
/* Copyright(C) 2001 Jonathan Lang <lang@synopsys.COM>                       */

#include <sys/stat.h>
#include <sys/swap.h>

/* initialize function */
int
mem_init (void)
{
  return 0;
}

/* return mem/swap usage in percent 0 to 100 */
int
get_memusage (int *per_mem, int *per_swap)
{
  static int mem_total;
  static int mem_free;
  static int swap_total;
  static int swap_free;
  struct anoninfo anon;

  /* get mem usage */
  mem_total = sysconf (_SC_PHYS_PAGES);
  mem_free = sysconf (_SC_AVPHYS_PAGES);

  /* get swap usage */
  if (swapctl (SC_AINFO, &anon) == -1)
    return -1;
  swap_total = anon.ani_max;
  swap_free = anon.ani_max - anon.ani_resv;

  /* calc mem/swap usage in percent */
  *per_mem = 100 * (1 - ((double) mem_free / (double) mem_total));
  *per_swap = 100 * (1 - ((double) swap_free / (double) swap_total));
  return 0;
}
